/*	
 *	standby2.c
 *
 *	A/Dϊ~߂X^oCEvO
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Tue Oct 2 06:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include "c33209.h"

void standby2();	/* A/Dϊ~߂X^oC֐ */

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */

/****************************************************************************
 *	
 ****************************************************************************/

void
pceAppInit()
{
	/* ʓIȏ */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceCPUSetSpeed(CPU_SPEED_HALF); /* X^oC̏ȓd͂̂ */
	pceLCDDispStart();

	/* ʕ\B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x80);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	pceFontSetPos(0, 0);
	/*             0123456789012345678901234 */
	pceFontPutStr("SELECT+BŻނ܂\n");
	pceFontPutStr("ޒADC~\n");
	pceFontPutStr("v͓Â܂\n");
	pceFontPutStr("\n");
	pceFontPutStr("STARTŻމ܂\n");
	pceFontPutStr("1b͖̉\n");
	pceFontPutStr("\n");
	pceFontPutStr("A{^ŏI܂\n");
}

void
pceAppProc(int count)
{
	int joy;

	/* L[͎擾B */
	joy = pcePadGet();

	/* A{^ŏIB */
	if(joy & TRG_A) {
		pceAppReqExit(0);
		return;
	}

	/* SELECT+BŃX^oCB */
	if((joy & PAD_SELECT) && (joy & TRG_B)) standby2();

	/* d\XV̂߂ɉʓ]B */
	pceLCDTrans();
}

void
pceAppExit()
{
}

/****************************************************************************
 *	standby2 - A/Dϊ~߂X^oC
 ****************************************************************************/

/* NMI~A/DϊfBZ[uX^oCNMI */
void
standby2()
{
	unsigned char saveNMI;

	/* * pcePowerEnterStandby()ĂԑOA/DϊfBZ[uĂĂA
	 *   pcePowerEnterStandby()̒"slp"ONMIƁA
	 *   GetPowerStat()Ă΂A/Dϊ킪Cl[uĂ܂܂B
	 *   h߂ɁANMI~ĂA/DϊfBZ[u܂B
	 * * KpcePowerEnterStandby()̓VXe^C}ĂȂ(RTCgp)
	 *   ̂ŁANMI~߂Ă܂ĂvƎv܂B
	 * * pcePowerEnterStandby()̒łNMI̕ۑE~EsĂ̂ŁA
	 *   ۑ~{ۑ~X[v}AƓdɂȂ܂A
	 *   Ȃ͂łB
	 */
	saveNMI = bWD_EN_EWD;	/* ݂̐ݒۑ(ONɌ܂Ă邯) */
	bWD_WP_WRWD = 1;	/* EWDCgveNg(񂾂L) */
	bWD_EN_EWD = 0;		/* EHb`hbO^C}~ */

	/* * A/DϊfBZ[u܂B
	 *   ݂P/ECEJ[ĺAA/Dϊ荞݂̒ōČvݒ̂߂
	 *   uA/DϊfBZ[uȊÓAɃCl[uɂĂ悤łB
	 * * A/DϊfBZ[u鏇ɒӂĂI
	 *   uA/Dϊ튄荞݂֎~vĂuA/DϊfBZ[uv܂B
	 *   tɂƁAfBZ[u`荞݋֎~̊ԂA/Dϊ荞݂ꍇA
	 *   int_ISR()̒ōĂуCl[uĂ܂\܂B
	 * * S1C33209/221/222eNjJ}jA
	 *   uIV-2 A/Dϊ vO~O̒ӎ (AcrobatReaderł407y[W)v
	 *   (6)ɂƁAA/Dϊ͌vłȂĂCl[uɂȂĂ邾
	 *   dĂ邻Ȃ̂ŁAfBZ[uΏd͂łB
	 * * ƂAu8.4 d (82y[W)v(3)AiOddɂ
	 *   A/Dϊ̏d500`800uAxȂ̂ŁAP/ECȆҋ@d6mAɊrׂ
	 *   Ă΂m܂񂪁EEE
	 */
	bINT_EP47_ECT_EAD_EADE = 0;	/* A/Dϊ튄荞݋֎~           */
	bINT_FP47_FCT_FAD_FADE = 0;	/* A/Dϊ튄荞݂mɃNA */
	bAD_EN_ADE = 0;			/* A/DϊfBZ[u           */

	/* X^oC[hցB */
	pcePowerEnterStandby(0);

	/* * A/Dϊ𖾎IɃCl[uKv͂܂B
	 *   NMI𕜌GetPowerStat()Ă΂悤ɂȂ΁A
	 *   GetPowerStat()Ă΂start_ADC()̒ŁA
	 *   A/DϊCl[uA荞݂ONɂ邩łB
	 */

	/* * NMIBōĂGetPowerStat()Ă΂悤ɂȂ܂B */
	bWD_WP_WRWD = 1;	/* EWDCgveNg(񂾂L) */
	bWD_EN_EWD = saveNMI;	/* EHb`hbO^C} */
}
